// simplified openal playback of sampledata

#include <AL/al.h>
#include <AL/alc.h>
//#include <AL/alext.h>
#include <AL/alut.h>

namespace geogame {

const static int MAX_SOURCES = 10;

class Bleep
{
public:
	static Bleep *Get();

	int Register(short *data, unsigned int size);
	int Register(float *data, unsigned int size);
	// loop refers the the looping channel to use
	int Play(int id, float freq, float vol, int loop=0);
	void Modify(int pid, float freq, float vol);
	void StopLoop(int loopid);
	
	~Bleep();
private:
	Bleep();
	
	ALCdevice *m_Device;
	ALCcontext *m_Context;
	unsigned int m_Sources[MAX_SOURCES];
	unsigned int m_LoopingSources[MAX_SOURCES];
	int m_CurrentSource;
	static Bleep *m_Singleton;
};
}
