#include <list>
#include "dada.h"

using namespace std;

#define ENTITYFLAG_ENEMY		       0x01
#define ENTITYFLAG_PROJECTILE	       0x02
#define ENTITYFLAG_EXPLOSION	       0x04
#define ENTITYFLAG_KEY			       0x08
#define ENTITYFLAG_CAUGHTKEY	       0x10
#define ENTITYFLAG_PARTICLES	       0x20
#define ENTITYFLAG_WEAPONPICKUP	       0x40
#define ENTITYFLAG_CAUGHT_WEAPONPICKUP 0x80

#ifndef ENTITY
#define ENTITY

namespace geogame {

class Entity
{
public:
	Entity() : m_Flags(0), m_RemoveMe(false) {}
	virtual ~Entity() {}
	
	virtual void Update(const list<Entity*> &world, const dVector &playerpos);
	virtual void Render()=0;
	virtual const dVector &GetPosition()=0;
	virtual float GetMass() { return 0; }
	virtual bool CheckCollide(const dVector &pos, float radius, bool damage=false)=0;
	
	bool RemoveMe() { return m_RemoveMe; }
	const list<Entity*> &GetNewEntities() { return m_NewEntities; }
	int GetFlags() { return m_Flags; }
	const dBoundingBox& GetBoundingBox() { return m_BoundingBox; }
	
protected:

	dBoundingBox m_BoundingBox;
	int m_Flags;
	bool m_RemoveMe;
	list<Entity*> m_NewEntities;
};
}
#endif
