// an experimental ultra low quality, game synth renderer
// for making bloops, bleeps and jitters

#include <map>
#include <string>

using namespace std;

namespace geogame {

class Feeble
{
public:
	Feeble();
	~Feeble();
		
	static unsigned int Samplerate;
	static float TimeLength;
	
	class Module
	{
	public:
		Module();
		virtual ~Module();
		
		virtual void Patch(const string &input, Module *p) { m_Inputs[input]=p; }		
		virtual float Execute();		
		virtual float Get(unsigned int n);
		float *GetBuffer() { return m_Buffer; }
		unsigned int GetSize() { return m_Size; }
		float GetInput(const string &name, unsigned int n);
		void Dump();
		
	protected:
	
		map<string,Module*> m_Inputs;
		float *m_Buffer;
		unsigned int m_Size;
		unsigned int m_Samplerate;
		float m_TimeLength;
	};
	
	class Value : public Module
	{
	public:
		Value(float value) : m_Value(value) {}
		~Value() {}
		virtual float Execute();
		float Get(unsigned int n) { return m_Value; }
	private:
		float m_Value;
	};
	
	class Mult : public Module
	{
	public:
		virtual float Execute();	
	private:
	};
	
	class Add : public Module
	{
	public:
		virtual float Execute();	
	private:
	};
	
		
	class Generator : public Module
	{
	public:
		enum Type{SINE,SQUARE,TRIANGLE,SAWTOOTH,REVSAW,NOISE};
		Generator(Type t);
		~Generator() {}
		
		virtual float Execute();		
	private:
	
		Type m_Type;
	};
	
	class Envelope : public Module
	{
	public:
		enum Type{RAMPUP,RAMPDOWN,HILL,VALLEY};
		Envelope(Type t);
		virtual ~Envelope() {}
		virtual float Execute();		
		
	private:
		Type m_Type;		
	};
	
private:
};
}
