#include "dada.h"
#include "entity.h"
#include <string>
#include <vector>

#ifndef KEY
#define KEY

namespace geogame {

class Pickup : public Entity
{
public:
	Pickup(const dVector &position, float lag);
	virtual ~Pickup();
	
	virtual void Update(const list<Entity*> &world, const dVector &playerpos);
	virtual void Render();
	virtual bool CheckCollide(const dVector &pos, float radius, bool damage=false);
	virtual float GetMass() { return 0; }
	virtual const dVector &GetPosition() { return m_Position; }

	void SetCaptureSound(int s) { m_CapureSound=s; }

protected:
	dVector m_Position;
	dVector m_Direction;
	float m_MaxSpeed;
	float m_MaxSpeedSq;
	bool  m_FollowingMode;
	float m_FollowDistSq;
	int	m_CapureSound;
};

class Key : public Pickup
{
public:
	Key(const dVector &position, float lag);
	virtual ~Key();
	
	virtual void Render();
	virtual void Update(const list<Entity*> &world, const dVector &playerpos);
};

class WeaponPickup : public Pickup
{
public:
	WeaponPickup(const dVector &position, float lag);
	virtual ~WeaponPickup();
	
	virtual void Render();
	virtual void Update(const list<Entity*> &world, const dVector &playerpos);	
};
}
#endif
