#include <GL/glut.h>
#include "particles.h"
#include "utils.h"

using namespace geogame;

Particles::Particle::Particle(const dVector &p,const dVector &d,const dVector &i):
Position(p),
Direction(d),
Inertia(i),
Age(0)
{
}


Particles::Particles(int maxparticles) : 
m_MaxParticles(maxparticles) 
{
	m_Flags|=ENTITYFLAG_PARTICLES;
}

Particles::~Particles() 
{
}
	
void Particles::Update(const list<Entity*> &world, const dVector &playerpos)
{
	for (list<Particle>::iterator i=m_Particles.begin(); i!=m_Particles.end(); i++)
	{
		i->Position+=i->Direction+i->Inertia;
		i->Inertia*=0.999;
		i->Age++;
	}
}

void Particles::Render()
{
	for (list<Particle>::iterator i=m_Particles.begin(); i!=m_Particles.end(); i++)
	{
		if (i->Age<100)
		{
			float size=0.5+(i->Age/50.0f);
			size*=size;
			glColor4f(1/(i->Age*0.01f),1/(i->Age*0.05f),i->Age/100.0f,(1-(i->Age/100.0f))/5.0f);
			glPushMatrix();
			glTranslatef(i->Position.x,i->Position.y,0);
			glScalef(size,size,size);
			Primitive::Get()->Particle();
			glPopMatrix();
		}
	}	
}

void Particles::AddParticle(const Particle &p)
{
	if (m_Particles.size()>(unsigned int)m_MaxParticles)
	{
		m_Particles.erase(m_Particles.begin());
	}
	
	m_Particles.push_back(p);
}
