#include <list>
#include "entity.h"

#ifndef PARTICLES
#define PARTICLES

namespace geogame {

class Particles: public Entity
{
public:
	Particles(int maxparticles);
	~Particles();

	class Particle
	{
	public:
		Particle(const dVector &p,const dVector &d,const dVector &i);
		dVector Position;
		dVector Direction;
		dVector Inertia;
		int Age;
	};

	virtual void Update(const list<Entity*> &world, const dVector &playerpos);
	virtual void Render();
	virtual const dVector &GetPosition() { return m_Position; }
	virtual bool CheckCollide(const dVector &pos, float radius, bool damage=false) { return false; }
	
	void AddParticle(const Particle &p);

private:
	dVector m_Position;
	int m_MaxParticles;
	list<Particle> m_Particles;
};
}
#endif
