#include "geogame.h"
#include <python2.3/Python.h>

class PyLevelBuilder
{
public:
	static PyLevelBuilder *Get();
	~PyLevelBuilder();
	
	void Setup(GeoGame *s) { m_Game=s; }
	void Source(const string &filename);
	void DoString(const string &script);
	
	static dMatrix m_Space;
	
	static PyObject *Scale(PyObject *self, PyObject* args);
	static PyObject *Translate(PyObject *self, PyObject* args);
	static PyObject *Rotate(PyObject *self, PyObject* args);	
	static PyObject *NewGeo(PyObject *self, PyObject* args);	
	
private:
	PyLevelBuilder();	
	GeoGame *m_Game;
	static PyLevelBuilder *m_Singleton;
	static PyMethodDef m_Methods[256];
	void BindingHelper(const string &name, PyCFunction func, int flags, const string &doc);
	int m_BindingCount;
	
	
	
};

